﻿using System;
using System.Drawing;
using MonoTouch.Foundation;
using MonoTouch.UIKit;
using Infragistics;

namespace CustomDataSource_Xamarin
{
	public partial class CustomDataSource_XamarinViewController : UIViewController
	{
		IGGridView grid;
		RowColumnReversedDataSourceHelper helper;

		static bool UserInterfaceIdiomIsPhone {
			get { return UIDevice.CurrentDevice.UserInterfaceIdiom == UIUserInterfaceIdiom.Phone; }
		}

		public CustomDataSource_XamarinViewController ()
			: base (UserInterfaceIdiomIsPhone ? "CustomDataSource_XamarinViewController_iPhone" : "CustomDataSource_XamarinViewController_iPad", null)
		{
		}

		public override void DidReceiveMemoryWarning ()
		{
			// Releases the view if it doesn't have a superview.
			base.DidReceiveMemoryWarning ();
			
			// Release any cached data, images, etc that aren't in use.
		}

		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();
			
			// Perform any additional setup after loading the view, typically from a nib.

			grid = new IGGridView ();
			grid.AutoresizingMask = UIViewAutoresizing.FlexibleHeight | UIViewAutoresizing.FlexibleWidth;
			grid.Frame = new RectangleF (0, 0, this.View.Bounds.Size.Width, this.View.Bounds.Size.Height);
			grid.ColumnWidth = IGColumnWidth.CreateNumericColumnWidth (150.0f);
			grid.HeaderHeight = 150;
			this.View.AddSubview (grid);

			helper = new RowColumnReversedDataSourceHelper ();
			helper.AutoGenerateColumns = false;

			IGGridViewColumnDefinition firstNameColumn = new IGGridViewColumnDefinition ("firstName");
			IGGridViewColumnDefinition lastNameColumn = new IGGridViewColumnDefinition ("lastName");
			IGGridViewColumnDefinition territoryColumn = new IGGridViewColumnDefinition ("territory");
			IGGridViewColumnDefinition yearToDateColumn = new IGGridViewColumnDefinition ("yearToDateSales");

			helper.ColumnDefinitions.Add (firstNameColumn);
			helper.ColumnDefinitions.Add (lastNameColumn);
			helper.ColumnDefinitions.Add (territoryColumn);
			helper.ColumnDefinitions.Add (yearToDateColumn);

			helper.Data = IGSalesmanItem.GenerateDate (10).ToArray();
			grid.DataSource = helper;

		}
	}
}

