﻿using System;
using MonoTouch.Foundation;
using MonoTouch.UIKit;
using System.Collections.Generic;

namespace CustomDataSource_Xamarin
{
	public class IGSalesmanItem : NSObject
	{
		#region Members
		string _imageName;
		#endregion // Members

		#region properties
		[Export("firstName")]
		public string FirstName{ get; set; }

		[Export("lastName")]
		public string LastName { get; set; }

		[Export("territory")]
		public string Territory { get; set; }

		[Export("yearToDateSales")]
		public int YearToDateSales { get; set; }

		[Export("image")]
		public UIImage Image 
		{ 
			get 
			{ 
				UIImage img = UIImage.FromBundle (_imageName);
				return img; 
			}
		}
		#endregion // properties


		public IGSalesmanItem ()
		{
			Dictionary<string,string> pictureDictionary = new  Dictionary<string,string> ();

			pictureDictionary.Add ( "Adam","GUY");
			pictureDictionary.Add ( "Bill","GUY");
			pictureDictionary.Add ( "Charlie","GUY");
			pictureDictionary.Add ( "Daniel","GUY");
			pictureDictionary.Add ( "Edward","GUY");
			pictureDictionary.Add ( "Frank","GUY");
			pictureDictionary.Add ( "Greg","GUY");
			pictureDictionary.Add ( "Howard","GUY");
			pictureDictionary.Add ( "Issac","GUY");
			pictureDictionary.Add ( "Jack","GUY");
			pictureDictionary.Add ( "Kyle","GUY");
			pictureDictionary.Add ( "Larry","GUY");
			pictureDictionary.Add ( "Michael","GUY");
			pictureDictionary.Add ( "Nathan","GUY");
			pictureDictionary.Add ( "Oscar","GUY");
			pictureDictionary.Add ( "Pete","GUY");
			pictureDictionary.Add ( "Ralph","GUY");
			pictureDictionary.Add ( "Steve","GUY");
			pictureDictionary.Add ( "Torrey","GUY");
			pictureDictionary.Add ( "Vince","GUY");
			pictureDictionary.Add ( "William","GUY");
			pictureDictionary.Add ( "Zeke","GUY");
			pictureDictionary.Add ( "Alina","GIRL");
			pictureDictionary.Add ( "Brenda","GIRL");
			pictureDictionary.Add ( "Christine","GIRL");
			pictureDictionary.Add ( "Danielle","GIRL");
			pictureDictionary.Add ( "Erin","GIRL");
			pictureDictionary.Add ( "Fiona","GIRL");
			pictureDictionary.Add ( "Gina","GIRL");
			pictureDictionary.Add ( "Holly","GIRL");
			pictureDictionary.Add ( "Irene","GIRL");
			pictureDictionary.Add ( "Jennifer","GIRL");
			pictureDictionary.Add ( "Katie","GIRL");
			pictureDictionary.Add ( "Liz","GIRL");


			List<string> firstNames = new List<string> ();
			firstNames.Add ("Adam");
			firstNames.Add ("Bill");
			firstNames.Add ("Charlie");
			firstNames.Add ("Daniel");
			firstNames.Add ("Edward");
			firstNames.Add ("Frank");
			firstNames.Add ("Greg");
			firstNames.Add ("Howard");
			firstNames.Add ("Issac");
			firstNames.Add ("Jack");
			firstNames.Add ("Kyle");
			firstNames.Add ("Larry");
			firstNames.Add ("Michael");
			firstNames.Add ("Nathan");
			firstNames.Add ("Oscar");
			firstNames.Add ("Pete");
			firstNames.Add ("Ralph");
			firstNames.Add ("Steve");
			firstNames.Add ("Torrey");
			firstNames.Add ("Vince");
			firstNames.Add ("William");
			firstNames.Add ("Zeke");
			firstNames.Add ("Alina");
			firstNames.Add ("Brenda");
			firstNames.Add ("Christine");
			firstNames.Add ("Danielle");
			firstNames.Add ("Erin");
			firstNames.Add ("Fiona");
			firstNames.Add ("Gina");
			firstNames.Add ("Holly");
			firstNames.Add ("Irene");
			firstNames.Add ("Jennifer");
			firstNames.Add ("Katie");
			firstNames.Add ("Liz");

			List<string> lastNames = new List<string> ();
			lastNames.Add ("Adams");
			lastNames.Add ("Betts");
			lastNames.Add ("Crowley");
			lastNames.Add ("Doran");
			lastNames.Add ("Ellis");
			lastNames.Add ("Fitzgerald");
			lastNames.Add ("Gable");
			lastNames.Add ("Holmes");
			lastNames.Add ("Irvine");
			lastNames.Add ("Jefferson");
			lastNames.Add ("Keefe");
			lastNames.Add ("Landry");
			lastNames.Add ("Mendoza");
			lastNames.Add ("Newberry");
			lastNames.Add ("Owens");
			lastNames.Add ("Perez");
			lastNames.Add ("Rooney");
			lastNames.Add ("Spencer");
			lastNames.Add ("Thomas");
			lastNames.Add ("Vargas");
			lastNames.Add ("Waddell");
			lastNames.Add ("Zimmerman");

			List<string> territories = new List<string> ();
			territories.Add ("Australia");
			territories.Add ("Bulgaria");
			territories.Add ("Canada");
			territories.Add ("Denmark");
			territories.Add ("Egypt");
			territories.Add ("France");
			territories.Add ("Greece");
			territories.Add ("Hungary");
			territories.Add ("Italy");
			territories.Add ("Japan");
			territories.Add ("Kenya");
			territories.Add ("Latvia");
			territories.Add ("Mexico");
			territories.Add ("Netherlands");
			territories.Add ("Oman");
			territories.Add ("Qatar");
			territories.Add ("Portugal");
			territories.Add ("Russia");
			territories.Add ("Sweden");
			territories.Add ("Turkey");
			territories.Add ("Uruguay");
			territories.Add ("Venezuela");
			territories.Add ("Yemen");
			territories.Add ("Zimbabwe");

			Random rand = new Random (((int)(DateTime.Now.Ticks % Int32.MaxValue)));

			uint randomIndex = (uint) ((uint)rand.Next () % firstNames.Count);
			this.FirstName = firstNames [(int)randomIndex];

			randomIndex =(uint) ((uint)rand.Next () % lastNames.Count);
			this.LastName = lastNames [(int)randomIndex];

			randomIndex =(uint) ((uint)rand.Next () % territories.Count);
			this.Territory = territories [(int)randomIndex];

			this.YearToDateSales = (int)(rand.Next () % 50000);

			randomIndex = ((uint)rand.Next () % 23) + 1;

			string numberName;
			if (randomIndex < 10) {
				numberName = "0"+randomIndex.ToString() ;
			} else {
				numberName = randomIndex.ToString ();
			}

			_imageName = "People/" + pictureDictionary [this.FirstName] + numberName + ".png";

		}

		public static  List<IGSalesmanItem> GenerateDate(int count)
		{
			List<IGSalesmanItem> newList = new List<IGSalesmanItem> ();

			for (int i = 0; i < count; i++) {
				newList.Add (new IGSalesmanItem ());
			}

			return newList;
		}

	}
}

